<template>
   <div class="app-container">
      <p style="font-size: 16px;font-weight: bold">采集模块配置：</p>
      <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="100px">
         <el-form-item label="采集模块IP" prop="ip">
            <el-input
               v-model="queryParams.ip"
               placeholder="请输入采集模块IP"
               clearable
               style="width: 240px"
            />
         </el-form-item>
         <el-form-item label="端口号" prop="port">
            <el-input
               v-model="queryParams.port"
               placeholder="请输入端口号"
               clearable
               style="width: 240px"
            />
         </el-form-item>
         <el-form-item label="采样频率" prop="configKey">
            <el-input
                v-model="queryParams.frequency"
                placeholder="请输入采样频率"
                clearable
                style="width: 240px"
            />
         </el-form-item>
         <el-form-item>
            <el-button type="primary" icon="Search" @click="startConnect" :disabled="isConnect">连接</el-button>
            <el-button icon="Refresh" @click="closeConnect" :disabled="!isConnect">断开连接</el-button>
         </el-form-item>
      </el-form>
      <p style="font-size: 16px;font-weight: bold;margin-top: 12px">振动传感器配置：</p>
      <el-row :gutter="10" class="mb8">
         <el-col :span="1.5">
            <el-button
               type="primary"
               plain
               icon="Plus"
               @click="handleAdd"
            >新增</el-button>
         </el-col>
         <!--<right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>-->
      </el-row>

      <el-table v-loading="loading" :data="configList" @selection-change="handleSelectionChange">
         <el-table-column type="selection" width="55" align="center" />
         <!--<el-table-column label="参数主键" align="center" prop="configId" />-->
         <el-table-column label="传感器编号" align="center" prop="code" :show-overflow-tooltip="true">
            <template #default="scope">
               <el-input v-model="scope.row.code" placeholder="请输入传感器编号"/>
            </template>
         </el-table-column>
         <el-table-column label="安装设备名称" align="center" prop="name" :show-overflow-tooltip="true">
            <template #default="scope">
               <el-input v-model="scope.row.name" placeholder="请输入安装设备名称"/>
            </template>
         </el-table-column>
         <el-table-column label="安装位置" align="center" prop="location" :show-overflow-tooltip="true">
            <template #default="scope">
               <el-input v-model="scope.row.location" placeholder="请输入安装位置"/>
            </template>
         </el-table-column>
         <el-table-column label="ICP" align="center" prop="icp" :show-overflow-tooltip="true">
            <template #default="scope">
               <el-select v-model="scope.row.icp" placeholder="请选择">
                  <el-option
                      v-for="dict in sensor_device_icp"
                      :key="dict.value"
                      :label="dict.label"
                      :value="dict.value"
                  />
               </el-select>
            </template>
         </el-table-column>
         <el-table-column label="灵敏度" align="center" prop="db" :show-overflow-tooltip="true">
            <template #default="scope">
               <el-input v-model="scope.row.db" placeholder="请输入灵敏度"/>
            </template>
         </el-table-column>
         <el-table-column label="模块通道号" align="center" prop="channelNumbers" :show-overflow-tooltip="true">
            <template #default="scope">
               <el-select v-model="scope.row.channelNumbers" multiple placeholder="请选择">
                  <el-option
                      v-for="dict in sensor_device_channel"
                      :key="dict.value"
                      :label="dict.label"
                      :value="dict.value"
                  />
               </el-select>
            </template>
         </el-table-column>
         <el-table-column label="是否使用" align="center" prop="used" :show-overflow-tooltip="true">
            <template #default="scope">
               <el-switch
                   v-model="scope.row.used"
                   active-color="#13ce66"
                   inactive-color="#ff4949">
               </el-switch>
            </template>
         </el-table-column>
         <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
            <template #default="scope">
               <el-tooltip content="删除" placement="top" v-if="scope.row.roleId !== 1">
                  <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"></el-button>
               </el-tooltip>
            </template>
         </el-table-column>
      </el-table>

      <p style="font-size: 16px;font-weight: bold;margin-top: 24px">电流传感器配置：</p>
      <el-row :gutter="10" class="mb8" style="margin-top: 24px">
         <el-col :span="1.5">
            <el-button
                type="primary"
                plain
                icon="Plus"
                @click="handleAdd1"
            >新增</el-button>
         </el-col>
         <!--<right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>-->
      </el-row>
      <el-table v-loading="loading" :data="configList1" @selection-change="handleSelectionChange">
         <el-table-column type="selection" width="55" align="center" />
         <!--<el-table-column label="参数主键" align="center" prop="configId" />-->
         <el-table-column label="传感器编号" align="center" prop="code" :show-overflow-tooltip="true">
            <template #default="scope">
               <el-input v-model="scope.row.code" placeholder="请输入传感器编号"/>
            </template>
         </el-table-column>
         <el-table-column label="安装设备名称" align="center" prop="name" :show-overflow-tooltip="true">
            <template #default="scope">
               <el-input v-model="scope.row.name" placeholder="请输入安装设备名称"/>
            </template>
         </el-table-column>
         <el-table-column label="安装位置" align="center" prop="location" :show-overflow-tooltip="true">
            <template #default="scope">
               <el-input v-model="scope.row.location" placeholder="请输入安装位置"/>
            </template>
         </el-table-column>
         <el-table-column label="量程上限" align="center" prop="location" :show-overflow-tooltip="true">
            <template #default="scope">
               <el-input v-model="scope.row.max" placeholder="请输入量程上限"/>
            </template>
         </el-table-column>
         <el-table-column label="量程下限" align="center" prop="location" :show-overflow-tooltip="true">
            <template #default="scope">
               <el-input v-model="scope.row.min" placeholder="请输入量程下限"/>
            </template>
         </el-table-column>
         <el-table-column label="模块通道号" align="center" prop="channelNumbers" :show-overflow-tooltip="true">
            <template #default="scope">
               <el-select v-model="scope.row.channelNumbers" multiple placeholder="请选择">
                  <el-option
                      v-for="dict in sensor_device_channel"
                      :key="dict.value"
                      :label="dict.label"
                      :value="dict.value"
                  />
               </el-select>
            </template>
         </el-table-column>
         <el-table-column label="是否使用" align="center" prop="used" :show-overflow-tooltip="true">
            <template #default="scope">
               <el-switch
                   v-model="scope.row.used"
                   active-color="#13ce66"
                   inactive-color="#ff4949">
               </el-switch>
            </template>
         </el-table-column>
         <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
            <template #default="scope">
               <el-tooltip content="删除" placement="top" v-if="scope.row.roleId !== 1">
                  <el-button link type="primary" icon="Delete" @click="handleDelete1(scope.row)"></el-button>
               </el-tooltip>
            </template>
         </el-table-column>
      </el-table>

      <div class="dialog-footer" style="margin-top: 24px;display: flex;justify-content: center">
         <el-button type="primary" @click="save">保存配置</el-button>
         <el-button type="primary" @click="start">开始采集</el-button>
         <el-button type="primary" @click="stop">停止采集</el-button>
      </div>
      <!--<pagination-->
      <!--   v-show="total > 0"-->
      <!--   :total="total"-->
      <!--   v-model:page="queryParams.pageNum"-->
      <!--   v-model:limit="queryParams.pageSize"-->
      <!--   @pagination="getList"-->
      <!--/>-->

      <!-- 添加或修改参数配置对话框 -->
      <el-dialog :title="title" v-model="open" width="500px" append-to-body>
         <el-form ref="configRef" :model="form" :rules="rules" label-width="80px">
            <el-form-item label="参数名称" prop="configName">
               <el-input v-model="form.configName" placeholder="请输入参数名称" />
            </el-form-item>
            <el-form-item label="参数键名" prop="configKey">
               <el-input v-model="form.configKey" placeholder="请输入参数键名" />
            </el-form-item>
            <el-form-item label="参数键值" prop="configValue">
               <el-input v-model="form.configValue" placeholder="请输入参数键值" />
            </el-form-item>
            <el-form-item label="系统内置" prop="configType">
               <el-radio-group v-model="form.configType">
                  <el-radio
                     v-for="dict in sys_yes_no"
                     :key="dict.value"
                     :label="dict.value"
                  >{{ dict.label }}</el-radio>
               </el-radio-group>
            </el-form-item>
            <el-form-item label="备注" prop="remark">
               <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
            </el-form-item>
         </el-form>
         <template #footer>
            <div class="dialog-footer">
               <el-button type="primary" @click="submitForm">确 定</el-button>
               <el-button @click="cancel">取 消</el-button>
            </div>
         </template>
      </el-dialog>
   </div>
</template>

<script setup name="Config">
import { listConfig, getConfig, delConfig, addConfig, sensorInfo, sensorSave,
   updateConfig, refreshCache, sensorConnect, sensorDisConnect, sensorStartGather,
sensorStopGather} from "@/api/system/config";

const { proxy } = getCurrentInstance();
const { sys_yes_no } = proxy.useDict("sys_yes_no");

const configList = ref([]);
const configList1 = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const dateRange = ref([]);
const isConnect = ref(false)

const { sensor_device_icp } = proxy.useDict("sensor_device_icp");
const { sensor_device_channel } = proxy.useDict("sensor_device_channel");
const data = reactive({
  form: {

  },
  queryParams: {
     id: '',
    pageNum: 1,
    pageSize: 10,
    ip: undefined,
    port: undefined,
     frequency: undefined
  },
  rules: {
    // configName: [{ required: true, message: "参数名称不能为空", trigger: "blur" }],
    // configKey: [{ required: true, message: "参数键名不能为空", trigger: "blur" }],
    // configValue: [{ required: true, message: "参数键值不能为空", trigger: "blur" }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询参数列表 */
function getList() {
  loading.value = true;
   sensorInfo().then(res => {
      if (res.data && res.data.length > 0){
         queryParams.value.ip =  res.data[0].ip
         queryParams.value.id =  res.data[0].id
         queryParams.value.port =  res.data[0].port
         queryParams.value.frequency =  res.data[0].frequency
         configList.value = JSON.parse( res.data[0].vibrateSensor);
         configList1.value = JSON.parse( res.data[0].electricSensor);
      }
   });
  // listConfig(proxy.addDateRange(queryParams.value, dateRange.value)).then(response => {
  //   configList.value = response.rows;
  //   total.value = response.total;
  //   loading.value = false;
  // });
  //  configList.value = [];
   total.value = 8;
   loading.value = false;
}
/** 取消按钮 */
function cancel() {
  open.value = false;
  reset();
}
/** 表单重置 */
function reset() {
  form.value = {
    configId: undefined,
    configName: undefined,
    configKey: undefined,
    configValue: undefined,
    configType: "Y",
    remark: undefined
  };
  proxy.resetForm("configRef");
}
/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

function startConnect() {
   sensorConnect({
      ...data.queryParams,
      vibrateSensor: JSON.stringify(configList.value),
      electricSensor: JSON.stringify(configList1.value)
   }).then(response => {
      proxy.$modal.msgSuccess("连接成功");
      isConnect.value = true;
   });
}

function closeConnect() {
   queryParams.ip = undefined;
   queryParams.port = undefined;
   queryParams.frequency = undefined;
    sensorDisConnect({
       ...data.queryParams,
       vibrateSensor: JSON.stringify(configList.value),
       electricSensor: JSON.stringify(configList1.value)
    }).then(response => {
        proxy.$modal.msgSuccess("断开连接成功");
        isConnect.value = false;
    });
}


/** 重置按钮操作 */
function resetQuery() {
  dateRange.value = [];
  proxy.resetForm("queryRef");
  handleQuery();
}
/** 多选框选中数据 */
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.configId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}
/** 新增按钮操作 */
function handleAdd() {
  // reset();
  // open.value = true;
  // title.value = "添加参数";
   configList.value.push({
      configId: 1,
      code: 'V0' + (configList.value.length+1),
      name: '',
      location: '',
      icp: '1',
      db: '100',
      channelNumbers: '',
      used: ''
   })
}
function handleAdd1() {
   // reset();
   // open.value = true;
   // title.value = "添加参数";
   configList1.value.push({
      configId: 1,
      code: 'C0' + (configList1.value.length+1),
      name: '',
      location: '',
      max: '25',
      min: '25',
      channelNumbers: '',
      used: ''
   })
}
/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const configId = row.configId || ids.value;
  getConfig(configId).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改参数";
  });
}

function start(){
   sensorStartGather({
      ...data.queryParams,
      vibrateSensor: JSON.stringify(configList.value),
      electricSensor: JSON.stringify(configList1.value)
   }).then(response => {
      proxy.$modal.msgSuccess("开始采集成功");
   })
}
function stop(){
   sensorStopGather({
      ...data.queryParams,
      vibrateSensor: JSON.stringify(configList.value),
      electricSensor: JSON.stringify(configList1.value)
   }).then(response => {
      proxy.$modal.msgSuccess("停止采集成功");
   })
}
function save(){
   sensorSave({
      ...data.queryParams,
      vibrateSensor: JSON.stringify(configList.value),
      electricSensor: JSON.stringify(configList1.value)
   }).then(response => {
      proxy.$modal.msgSuccess("保存成功");
   });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["configRef"].validate(valid => {
    if (valid) {
      if (form.value.configId != undefined) {
        updateConfig(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addConfig(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}
/** 删除按钮操作 */
function handleDelete(row) {
  const configIds = row.configId || ids.value;
  proxy.$modal.confirm('是否确认删除参数编号为"' + configIds + '"的数据项？').then(function () {
     configList.value.splice(configList.value.indexOf(row), 1);
    return true;
  }).then(() => {
    // getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}
function handleDelete1(row) {
   const configIds = row.configId || ids.value;
   proxy.$modal.confirm('是否确认删除参数编号为"' + configIds + '"的数据项？').then(function () {
      configList1.value.splice(configList1.value.indexOf(row), 1);
      return true;
   }).then(() => {
      // getList();
      proxy.$modal.msgSuccess("删除成功");
   }).catch(() => {});
}
/** 导出按钮操作 */
function handleExport() {
  proxy.download("system/config/export", {
    ...queryParams.value
  }, `config_${new Date().getTime()}.xlsx`);
}
/** 刷新缓存按钮操作 */
function handleRefreshCache() {
  refreshCache().then(() => {
    proxy.$modal.msgSuccess("刷新缓存成功");
  });
}

getList();
</script>
